"use strict";

var browser = {}, app, Port, cfg, _, LNG;

if (document instanceof window.HTMLDocument) {
	browser = document.documentElement || document.createElementNS("http://www.w3.org/1999/xhtml", "div");

	if (!window.requestAnimationFrame) {
		window.requestAnimationFrame = window.webkitRequestAnimationFrame
			|| window.mozRequestAnimationFrame || function(cb) { return window.setTimeout(cb, 20); };
	}

	if (browser.style) {
		_ = browser.style;

		browser = {
			"wheel": "onwheel" in browser ? "wheel" : "mousewheel", // Firefox <17 uses DOMMouseScroll, corrected below
			"transform": ("webkitTransform" in _ ? "webkitT" : ("OTransform" in _ ? "OT" : ("MozTransform" in _ ? "MozT" : "t"))) + "ransform",
			"transform_css": ("webkitTransform" in _ ? "-webkit-" : ("OTransform" in _ ? "-o-" : ("MozTransform" in _ ? "-moz-" : ""))) + "transform",
			"transition_css": ("webkitTransition" in _ ? "-webkit-" : ("OTransition" in _ ? "-o-" : ("MozTransition" in _ ? "-moz-" : ""))) + "transition",
			"transitionend": "webkitTransition" in _ ? "webkitTransitionEnd" : ("OTransition" in _ ? "oTransitionEnd" : "transitionend"),
			"box-sizing_css": ("MozBoxSizing" in _ ? "-moz-" : ("WebkitBoxSizing" in _ ? "-webkit-" : "")) + "box-sizing",
			"zoom-in": this.chrome || this.mx || this.safari ? "-webkit-zoom-in" : "zoom-in" // Firefox <24 needs -moz-, corrected below
		};
	}
}

var media_type = function() {
	if (document.media_type) {
		return document.media_type;
	}

	var d = document, img = d.images && d.images.length === 1 && d.images[0];

	if (img && img.parentNode === d.body && img.src === window.location.href) {
		return document.media_type = "img";
	}

	d = d.querySelectorAll("body > video:first-child, body > div > video:first-child");

	if (d && d.length === 1) {
		return document.media_type = "video";
	}
};

app = {
	"name": /*~APP_NAME~*/"Viewhance",
	"version": /*~APP_VERSION~*/"0.9.1"
};


Port = {
	listen: function(listener) {
		if (this.listener) {
			opera.extension.removeEventListener("message", this.listener, false);
		}

		this.listener = listener;

		if (listener) {
			opera.extension.addEventListener("message", this.listener, false);
		}
	},
	send: function(msg) {
		opera.extension.postMessage(msg);
	}
};

if (opera.extension.bgProcess) {
	_ = function(s) {
		return typeof LNG === "object" && LNG[s] || s;
	};

	LNG = document.createElement("script");
	LNG.src = "./" + location.pathname.slice(1, location.pathname.indexOf('.')) + "_lng.js";
	document.head.appendChild(LNG);

	cfg = {
		getItem: function(k, fn) {
			fn(widget.preferences.getItem(k));
		}
	};
}

browser.opera = true;
